#if !defined(VOCAL_VTHREAD_H)
#define VOCAL_VTHREAD_H

/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */

static const char* const vthread_h_Version =
    "$Id: vthread.h,v 1.2 2001/06/29 03:56:00 bko Exp $";


#if defined(_WIN32)

#if 0
    // this is not valid until someone finishes forming a native thread port
    // for win32.  right now, we are still using posix threads on win32
    #if !defined(VOCAL_USE_WIN32_THREADS)
    #define VOCAL_USE_WIN32_THREADS
    #endif
#endif
    // we can replace this with win32 threads
    #if !defined(VOCAL_USE_POSIX_THREADS)
    #define VOCAL_USE_POSIX_THREADS
    #endif

#elif defined(__vxworks)

    #if !defined(VOCAL_USE_VXWORKS_THREADS)
    #define VOCAL_USE_VXWORKS_THREADS
    #endif

#else 

    #if !defined(VOCAL_USE_POSIX_THREADS)
    #define VOCAL_USE_POSIX_THREADS
    #endif

#endif


#if defined(VOCAL_USE_WIN32_THREADS)

    #include "win32/vthread.h"

#elif defined(VOCAL_USE_VXWORKS_THREADS)

    #include "vxworks/vthread.h"
    
#elif defined(VOCAL_USE_UNIX_THREADS)

    #include "unix/vthread.h"
    
#elif defined(VOCAL_USE_POSIX_THREADS)

    #include "posix/vthread.h"
    
#else

    #error Threading unknown

#endif


#endif // !defined(VOCAL_VTHREAD_H)
